# -*- coding: utf-8 -*-
from PyQt6.QtCore import Qt , QSize
from PyQt6.QtWidgets import QMainWindow,QWidget, QPushButton, QStyle,QGraphicsDropShadowEffect, QComboBox, QFileDialog, QListView, QGridLayout, QLineEdit, QLabel, QTabWidget, QGroupBox, QVBoxLayout, QCheckBox, QHBoxLayout
from PyQt6.QtGui import QStandardItem, QIcon, QStandardItemModel, QColor
from pathlib import Path
from utils import Utils

class OptionsVideo(QMainWindow):
    def __init__(self, application, parent=None,objectName=None):
        super(OptionsVideo, self).__init__(parent=parent)
        self.setObjectName(objectName)
        self.ut = Utils()
        self.enum_video_codecs = QComboBox(objectName="enum_video_codecs")
        self.enum_video_codecs.addItems(self.ut.get_video_codecs())
        self.enum_quality = QComboBox(objectName="enum_quality")
        self.enum_quality.addItems(self.ut.get_q_settings())
        self.enum_preset = QComboBox(objectName="enum_preset")
        self.enum_preset.addItems(self.ut.get_q_preset())
        self.enum_tunes = QComboBox(objectName="enum_tunes")
        self.enum_tunes.addItems(self.ut.get_q_tunes())
        self.enum_profile = QComboBox(objectName="enum_profile")
        self.enum_profile.addItems(self.ut.get_q_profile())
        self.use_preset = QCheckBox("Use preset",objectName="use_preset")
        self.use_tune = QCheckBox("Use tune",objectName="use_tune")
        self.use_profiles = QCheckBox("Use profile",objectName="use_profiles")
        self.layout_video = QVBoxLayout()
        self.video_group = QGroupBox("Use Video")
        self.video_group.setProperty("subtab", "on")
        self.setCentralWidget(self.video_group)
        self.video_group.setObjectName("video_group")
        self.video_group.setAlignment(Qt.AlignmentFlag.AlignTop)
        self.video_group.setCheckable(True)
        self.video_group.setFixedHeight(400)
        self.placeholder_v = QLabel(" ")
        self.video_group.setLayout(self.layout_video)
        self.layout_video_line0 = QHBoxLayout()
        self.use_og_video = QCheckBox("Keep original video stream",objectName="use_og_video")
        self.layout_video_line0.addWidget(self.use_og_video)
        self.layout_video.addLayout(self.layout_video_line0)
        self.codec_line = QHBoxLayout()
        self.layout_video.addLayout(self.codec_line)
        self.codec_label = QLabel("Codec:")
        self.codec_line.addWidget(self.codec_label)
        self.codec_line.addWidget(self.enum_video_codecs)
        self.placeholder0 = QLabel(" ")
        self.codec_line.addWidget(self.placeholder0, Qt.AlignmentFlag.AlignLeft)
        self.layout_qual = QVBoxLayout()
        self.qual_group = QGroupBox("Codec Options:")
        self.qual_group.setLayout(self.layout_qual)
        self.qual_group.setObjectName("titlequal")
        self.qual_group.setProperty("subtab", "on")
        self.layout_video.addWidget(self.qual_group)
        self.gop_line = QHBoxLayout()
        self.layout_qual.addLayout(self.gop_line)
        self.gop = QLineEdit("15",objectName="gop")
        self.gop_label = QLabel("Gop:")
        self.crf = QLineEdit("15",objectName="crf")
        self.use_crf = QCheckBox("Use crf:",objectName="use_crf")
        self.use_hwaccel = QCheckBox("Use GPU accel",objectName="use_hwaccel")
        self.placeholder11 = QLabel(" ")
        self.placeholder21 = QLabel(" ")
        self.gop.setFixedWidth(68)
        self.gop_label.setFixedWidth(45)
        self.gop_line.addWidget(self.gop_label, Qt.AlignmentFlag.AlignLeft)
        self.gop_line.addWidget(self.gop, Qt.AlignmentFlag.AlignLeft)
        self.gop_line.addWidget(self.placeholder11, Qt.AlignmentFlag.AlignLeft)
        self.gop_line.addWidget(self.use_crf, Qt.AlignmentFlag.AlignLeft)
        self.gop_line.addWidget(self.crf, Qt.AlignmentFlag.AlignLeft)
        self.gop_line.addWidget(self.placeholder21, Qt.AlignmentFlag.AlignLeft)
        self.gop_line.addWidget(self.use_hwaccel, Qt.AlignmentFlag.AlignLeft)
        self.selector_line_0 = QHBoxLayout()
        self.layout_video.addLayout(self.selector_line_0)
        self.selector_line_0.addWidget(self.use_preset)
        self.selector_line_0.addWidget(self.enum_preset)
        self.placeholder_p0 = QLabel(" ")
        self.selector_line_0.addWidget(self.placeholder_p0, Qt.AlignmentFlag.AlignLeft)
        self.selector_line_0.addWidget(self.use_tune)
        self.selector_line_0.addWidget(self.enum_tunes)
        self.placeholder_p1 = QLabel(" ")
        self.selector_line_0.addWidget(self.placeholder_p1, Qt.AlignmentFlag.AlignLeft)
        self.selector_line_0.addWidget(self.use_profiles)
        self.selector_line_0.addWidget(self.enum_profile)
        self.placeholder_p2 = QLabel(" ")
        self.selector_line_0.addWidget(self.placeholder_p2, Qt.AlignmentFlag.AlignLeft)
        self.compat_mode = QCheckBox("Encode for old players",objectName="compat_mode")
        self.keep_fps = QCheckBox("Keep framerate",objectName="keep_fps")
        self.fps_line = QHBoxLayout()
        self.layout_video.addLayout(self.fps_line)
        self.fps = QLineEdit("25",objectName="fps")
        self.fps.setFixedWidth(70)
        self.fps_label = QLabel("Fps:")
        self.fps_label.setFixedWidth(30)
        self.fps_line.addWidget(self.fps_label, Qt.AlignmentFlag.AlignLeft)
        self.fps_line.addWidget(self.fps, Qt.AlignmentFlag.AlignLeft)
        self.fps_line.addWidget(self.keep_fps, Qt.AlignmentFlag.AlignLeft)
        self.fps_line.addWidget(self.compat_mode, Qt.AlignmentFlag.AlignLeft)
        self.hflip = QCheckBox("Flip Horizontally",objectName="hflip")
        self.vflip = QCheckBox("Flip Vertically",objectName="vflip")
        self.reverse = QCheckBox("Reverse video",objectName="reverse")
        self.hflip.setProperty("stylefield", "on")
        self.vflip.setProperty("stylefield", "on")
        self.reverse.setProperty("stylefield", "on")
        self.layout_video_line3 = QHBoxLayout()
        self.use_scaler = QCheckBox("Rescale",objectName="use_scaler")
        self.placeholder_s0 = QLabel(" ")
        self.scaler = QLineEdit("1920:1080",objectName="scaler")
        self.scaler.setFixedWidth(90)
        self.use_scaler.setFixedWidth(80)
        self.layout_video.addLayout(self.layout_video_line3)
        self.layout_video_line3.addWidget(self.use_scaler, Qt.AlignmentFlag.AlignLeft)
        self.layout_video_line3.addWidget(self.scaler, Qt.AlignmentFlag.AlignLeft)
        self.layout_video_line3.addWidget(self.placeholder_s0, Qt.AlignmentFlag.AlignLeft)

        self.layout_video_line4 = QHBoxLayout()
        self.layout_video.addLayout(self.layout_video_line4)
        self.layout_video_line4.addWidget(self.hflip, Qt.AlignmentFlag.AlignLeft)

        self.layout_video_line42 = QHBoxLayout()
        self.layout_video.addLayout(self.layout_video_line42)
        self.layout_video_line42.addWidget(self.vflip, Qt.AlignmentFlag.AlignLeft)

        self.layout_video_line43 = QHBoxLayout()
        self.layout_video.addLayout(self.layout_video_line43)
        self.layout_video_line43.addWidget(self.reverse, Qt.AlignmentFlag.AlignLeft)
        self.add_watermark = QCheckBox("Add Watermark:",objectName="add_watermark")

        self.layout_video_line44 = QHBoxLayout()
        self.layout_video.addLayout(self.layout_video_line44)

        self.watermark_file = QLineEdit(objectName="watermark_file")
        self.watermark_field = QLineEdit(objectName="watermark_field")
        self.watermark_file_btn = QPushButton()
        appIcon = QIcon(":/folder.png")
        self.watermark_file_btn.setIcon(appIcon)
        self.placeholder101 = QLabel(" ")
        self.watermark_field_lbl = QLabel("Text:")
        self.add_watermark.setFixedWidth(150)
        self.watermark_file.setFixedWidth(250)
        self.watermark_field_lbl.setFixedWidth(30)
        self.watermark_file_btn.setFixedWidth(26)
        self.layout_video_line44.addWidget(self.add_watermark, Qt.AlignmentFlag.AlignLeft)
        self.layout_video_line44.addWidget(self.watermark_file, Qt.AlignmentFlag.AlignLeft)
        self.layout_video_line44.addWidget(self.watermark_file_btn, Qt.AlignmentFlag.AlignLeft)
        self.layout_video_line44.addWidget(self.watermark_field_lbl, Qt.AlignmentFlag.AlignLeft)
        self.layout_video_line44.addWidget(self.watermark_field, Qt.AlignmentFlag.AlignLeft)

        self.layout_video_line44.addWidget(self.placeholder101, Qt.AlignmentFlag.AlignLeft)

        attr_list = [self.reverse,self.add_watermark,self.watermark_file,self.watermark_file_btn, self.vflip, self.hflip,self.use_og_video, self.fps, self.fps_label, self.keep_fps, self.gop_label, self.gop, self.enum_video_codecs, self.codec_label]
        self.set_shadows(attr_list)

    def set_shadows(self, attr_list):

        for attr in attr_list:
            effect = QGraphicsDropShadowEffect(self)
            effect.setBlurRadius(2)
            effect.setOffset(1, 2)
            effect.setColor(QColor(16, 16, 16, 64))
            attr.setGraphicsEffect(effect)
